EDIT - bug #7870

RegistrationWorkingsetEditor: Internal error on clicking "new name"
10/26/2018 09:01 AM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 5.5

Severity: critical Found in Version:

Description

Encrypted by a verified device
14:04 als submitter eine neue Referenz angelegt (StartRegistrationView), dann new "Continue" bei Klicken im
RegistrationWorkingsetEditor auf New name "Internal Error"

http://test.e-taxonomy.eu/cdmserver/phycobank/app/registration#!workingset/5d595e64-71b5-4d56-b7d2-90b4ac4de8ca

Bei Escape folgende Meldung:

eu.etaxonomy.cdm.database.PermissionDeniedException: [UPDATE] not permitted for 'submitter2' on Te
am[uuid:34426499-8ffe-48aa-bcbl-34e2abdea676', toString:'Turland, N.J., Wiersema, J.H., Barrie, F.
R. & al.']

at eu.etaxonomy.cdm.persistence.hibernate.CdmSecurityHibernateInterceptor.checkPermissions (Cdm
SecurityHibernateInterceptor.java:207)

at eu.etaxonomy.cdm.persistence.hibernate.CdmSecurityHibernateInterceptor.onFlushDirty (CdmSecu
rityHibernateInterceptor. java:129)

at org.hibernate.event.internal.DefaultFlushEntityEventListener.invokelInterceptor (DefaultFlush
EntityEventListener. java:348)

at org.hibernate.event.internal.DefaultFlushEntityEventListener.handleInterception (DefaultFlus
hEntityEventListener.java:325)

at org.hibernate.event.internal.DefaultFlushEntityEventListener.scheduleUpdate (DefaultFlushEnt
ityEventListener. java:276)

at org.hibernate.event.internal.DefaultFlushEntityEventListener.onFlushEntity (DefaultFlushEnti
tyEventListener. java:143)

at org.hibernate.event.internal.AbstractFlushingEventListener.flushEntities (AbstractFlushingEv
entListener. java:216)

at org.hibernate.event.internal.AbstractFlushingEventListener.flushEverythingToExecutions (Abst
ractFlushingEventListener. java:85)

at org.hibernate.event.internal.DefaultAutoFlushEventListener.onAutoFlush (DefaultAutoFlushEven
tListener. java:44)

at org.hibernate.internal.SessionImpl.autoFlushIfRequired(SessionImpl.java:1251)

at org.hibernate.internal.SessionImpl.list (SessionImpl.java:1767)

at org.hibernate.internal.CriterialImpl.list (CriteriaImpl.java:363)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.findByUuid (CdmEntityDaoB
ase.java:423)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.findByUuid (CdmEntityDaoB
ase.java:410)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.findByUuid (Versionable
DaoBase.java:67)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.findByUuid (Versionable
DaoBase. java:36)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.load (CdmEntityDaoBase. ja
va:741)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.load (VersionableDaoBas
e.java:93)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.VersionableDaoBase.load (VersionableDaoBas
e.java:36)

at eu.etaxonomy.cdm.api.service.ServiceBase.load(ServiceBase. java:184)

at eu.etaxonomy.cdm.api.service.ServiceBase.load(ServiceBase. java:42)

at sun.reflect.GeneratedMethodAccessorl795.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)
at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (
TransactionInterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:281)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy661.load (Unknown Source)

at eu.etaxonomy.cdm.api.service.registration.RegistrationWorkingSetService.loadWorkingSetByRef
erenceUuid (RegistrationWorkingSetService. java:281)

at sun.reflect.GeneratedMethodAccessorl978.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.RAopUtils.invokeJoinpointUsingReflection (AopUtils.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (
TransactionInterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:281)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor. java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy753.loadWorkingSetByReferenceUuid (Unknown Source)

at eu.etaxonomy.cdm.vaadin.view.registration.RegistrationWorkingsetPresenter.loadWorkingSet (Re
gistrationWorkingsetPresenter. java:329)

at eu.etaxonomy.cdm.vaadin.view.registration.RegistrationWorkingsetPresenter.handleViewEntered
(RegistrationWorkingsetPresenter. java:259)

at eu.etaxonomy.cdm.vaadin.view.registration.RegistrationWorksetViewBean.enter (RegistrationWor
ksetViewBean. java:166)

at com.vaadin.navigator.Navigator.navigateTo (Navigator.java:625)

at com.vaadin.navigator.Navigator.navigateTo (Navigator.java:584)

at eu.etaxonomy.vaadin.ui.navigation.NavigationManagerBean.navigateTo (NavigationManagerBean. ja
va:143)

at com.vaadin.ui.UI.doInit (UI.java:698)

at com.vaadin.server.communication.UIInitHandler.getBrowserDetailsUI (UIInitHandler.java:222)

at com.vaadin.server.communication.UIInitHandler.synchronizedHandleRequest (UIInitHandler. java:
74)

at com.vaadin.server.SynchronizedRequestHandler.handleRequest (SynchronizedRequestHandler. java:
41)

at com.vaadin.server.VaadinService.handleRequest (VaadinService.java:1435)

at com.vaadin.server.VaadinServlet.service (VaadinServlet.java:380)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:808)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (FilterSe
curityInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Filter
SecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTransl
ationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr

security.web.FilterChainProxy.doFilterInternal (FilterChainProxy.java:21

security.web.FilterChainProxy.doFilter (FilterChainProxy.java:176)
web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. j

web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy.java:26

eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)

web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFi

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:107)

servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
servlet.ServletHandler.doHandle (ServletHandler. java:585)
server.handler.ScopedHandler.handle (ScopedHandler. java:143)
security.SecurityHandler.handle (SecurityHandler. java:577)
server.session.SessionHandler.doHandle (SessionHandler. java:223)
server.handler.ContextHandler.doHandle (ContextHandler.java:1127)
servlet.ServletHandler.doScope (ServletHandler. java:515)

session.SessionHandler.doScope (SessionHandler. java:185)
.handler.ContextHandler.doScope (ContextHandler.java:1061)
.handler.ScopedHandler.handle (ScopedHandler. java:141)
handler.ContextHandlerCollection.handle (ContextHandlerCollection.j
at org.eclipse.jetty.server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)
at org.eclipse.jetty.server.Server.handle (Server. java:497)

at org.eclipse.jetty.server.HttpChannel.handle (HttpChannel. java:310)

at org.eclipse.jetty.server.HttpConnection.onFillable (HttpConnection. java:257)

at org.eclipse.jetty.io.AbstractConnection$2.run (AbstractConnection. java:540)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)
at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)
at java.lang.Thread.run (Thread. java:748)

14:23 vielleicht ist wieder eine Session kaputt, submitter2 login funktioniert, aber bereits die Auswahl einer Referenz wirft einen
internal error.

Der internal error wird nicht beim reinen Auswahlen geworfen, sondern wenn ich in die Auswahl "A" oder "Ab" eingebe.

Related issues:
Copied to EDIT - bug #7874: TeamOrPersonBase entity can become unusable due t... Closed

Associated revisions

Revision 4329130b - 10/26/2018 06:21 PM - Andreas Kohlbecker

ref #7870 adding the WindowErrorHandler also to the VaadinSession to also get hold of 'internal errors'

Revision 1bc25606 - 10/26/2018 06:22 PM - Andreas Kohlbecker

ref #7870 clearing the session to wipe out any left overs from previous usage of the session in handleViewEntered

History

#1 - 10/26/2018 01:29 PM - Andreas Kohlbecker
- Target version changed from Update Documentation to Release 5.5

- Severity changed from normal to critical

The initial problem is cause by the protectedNomenclaturalTitleCache flag of the Team being set to false. When binding the data to the Ul the
getNomenclaturalTitle() is called which causes the the nomenclaturalTitle being updated using the cache strategy. The value stored in the db is now
different from the value contained in the nomenclaturalTitle-field:

nomenclaturalTitle in db:

Turland, Wiersema, Barrie, Greuter, D.Hawksw., Herend., S.Knapp, Kusber, D.Z.Li, Marhold, T.W.May, McNeill, A.
M.Monro, J.Prado, M.J.Price & Gideon F.Sm.

nomenclaturalTitle in loaded entity:
Turland, Wiersema, Barrie, Greuter, D.Hawksw., Herend., S.Knapp, Kusber, D.Z.Li, Marhold, T.W.May, McNeill, Mo
nro, A.M., J.Prado, M.J.Price & Gideon F.Sm.

The Team entity is loaded as part of the object graph which belongs to the reference. The submitter has no UPDATE permission for this Team. But
saving the Reference will cause the Team being flushed to the data base. However the getter has changed the value of the nomenclaturalTitle-field
and the user is required to have the UPDATE permission and a PermissionDeniedException is thrown.

One could now point out that the Team in in an inconsistent state since the nomenclaturalTitle differs from the value generated by the cache even if
the protectedNomenclaturalTitleCache value is is false. But is seems as if this Team has been created by user henning manually using the Taxeditor
(last updated on 2018-04-24 16:52:32). So this is not an import issue.

Either the Taxeditor must never leave Teams in such an inconsistent state or we need to find a way do deal with these situations in the entity class
and/or during the flush operation.

This is really critical since it blocks underprivileged users from using object without having the UPDPATE permission.

#2 - 10/26/2018 01:42 PM - Andreas Miiller
AM:

ganz so kritisch ist es glaube ich nicht. Letztlich muss man nur den cache updaten mit dem Cacheupdater. Allerdings sollte man sich dabei vorher
ganz sicher sein, dass auch alle Daten, die NICHT protected sind richtig atomisiert vorliegen.

Das Problem kommt durch die Umstellung der TitleCaches auf Initials hinter dem Namen. Da die notTitles auch mit dem TitleCache gefullt werden,
wenn keine expliziten nomTitles vorliegen, werden die damit auch geandert.

Eigentlich soll auf allen DBs friiher oder spéter der Cacheupdater laufen. ABER: zumindest von Palmweb weif3 ich, dass es da noch Daten gibt, die
nicht protected sind und auch nicht atomisiert. Deswegen habe ich das noch verschoben, bis ich Zeit habe, die Daten vorher kurz zu checken.

Wie gesagt, wenn ihr euch bei Phycobank sicher seid, dass alles stimmt, sollte es kein Problem sein.

Ansonsten missen wir eben méglichst bals mal an das Cache Handling bzgl. Permissions ran wie kirzlich besprochen (mit System Rechten und so)
#3 - 10/26/2018 01:44 PM - Andreas Kohlbecker

- Copied to bug #7874: TeamOrPersonBase entity can become unusable due to replacement of the title caches on using getters added

#4 - 10/26/2018 01:45 PM - Andreas Kohlbecker

above sub issue copied to #7874

#5 - 10/26/2018 06:24 PM - Andreas Kohlbecker
- Status changed from New to Closed

- % Done changed from 0 to 100

| added to modifications

e adding the WindowErrorHandler also to the VaadinSession
e clearing the session to wipe out any left overs from previous usage of the session in handleViewEntered

which should futher help avoid running in to corrupted sessions and to debug problems more easily
Nothing else to do here since the main issue is handled in #7874

#6 - 01/25/2019 03:06 PM - Andreas Miiller

- Subject changed from RegistrationWorkingsetEditor: Intenral error on clicking "new name" to RegistrationWorkingsetEditor: Internal error on clicking
"new name"
